/* $Id$ */

#define SYSC_BASE 0x30

#define	SYSC_FORK	(SYSC_BASE + 0x00)
#define	SYSC_STOP	(SYSC_BASE + 0x01)
#define	SYSC_KILL	(SYSC_BASE + 0x02)
#define	SYSC_CONNECT	(SYSC_BASE + 0x03)
#define	SYSC_JOIN	(SYSC_BASE + 0x04)
#define	SYSC_CLOSE	(SYSC_BASE + 0x05)
#define	SYSC_SEND	(SYSC_BASE + 0x06)
#define	SYSC_RECEIVE	(SYSC_BASE + 0x07)
#define	SYSC_ISSUE	(SYSC_BASE + 0x08)
#define	SYSC_MAPTO	(SYSC_BASE + 0x09)
#define	SYSC_SIGNAL	(SYSC_BASE + 0x0a)
#define	SYSC_SELECT	(SYSC_BASE + 0x0b)
#define	SYSC_TIMEOUT	(SYSC_BASE + 0x0c)
#define	SYSC_QUANTUM	(SYSC_BASE + 0x0d)
#define	SYSC_UNMAP	(SYSC_BASE + 0x0e)
#define	SYSC_TIME	(SYSC_BASE + 0x0f)
#define	SYSC_ERROR	(SYSC_BASE + 0x10)
#define	SYSC_PUTCHAR	(SYSC_BASE + 0x11)
#define	SYSC_GETCHAR	(SYSC_BASE + 0x12)

#define ENTRY(x)	.globl x; x :

	.text

ENTRY(fork)
	movl	4(%esp), %eax
	int	$SYSC_FORK
	ret

ENTRY(stop)
	int	$SYSC_STOP
	ret

ENTRY(kill)
	movl	4(%esp), %eax
	int	$SYSC_KILL
	ret

ENTRY(connect)
	movl	4(%esp), %eax
	int	$SYSC_CONNECT
	ret

ENTRY(join)
	pushl	%ebx
	movl	8(%esp), %eax
	movl	12(%esp), %ebx
	int	$SYSC_JOIN
	popl	%ebx
	ret

ENTRY(close)
	movl	4(%esp), %eax
	int	$SYSC_CLOSE
	ret

ENTRY(send)
	pushl	%ebx
	pushl	%ecx
	movl	12(%esp), %eax
	movl	16(%esp), %ebx
	movl	20(%esp), %ecx
	int	$SYSC_SEND
	popl	%ecx
	popl	%ebx
	ret

ENTRY(receive)
	pushl	%ebx
	pushl	%ecx
	movl	12(%esp), %eax
	movl	16(%esp), %ebx
	movl	20(%esp), %ecx
	int	$SYSC_RECEIVE
	popl	%ecx
	popl	%ebx
	ret

ENTRY(issue)
	pushl	%ebx
	pushl	%ecx
	pushl	%edx
	pushl	%esi
	pushl	%edi
	movl	24(%esp), %eax
	movl	28(%esp), %ebx
	movl	32(%esp), %ecx
	movl	36(%esp), %edx
	movl	40(%esp), %esi
	movl	44(%esp), %edi
	int	$SYSC_ISSUE
	popl	%edi
	popl	%esi
	popl	%edx
	popl	%ecx
	popl	%ebx
	ret

ENTRY(mapto)
	pushl	%ebx
	pushl	%ecx
	pushl	%edx
	pushl	%esi
	movl	20(%esp), %eax
	movl	24(%esp), %ebx
	movl	28(%esp), %ecx
	movl	32(%esp), %edx
	movl	36(%esp), %esi
	int	$SYSC_MAPTO
	popl	%esi
	popl	%edx
	popl	%ecx
	popl	%ebx
	ret

ENTRY(signal)
	pushl	%ebx
	pushl	%ecx
	movl	12(%esp), %eax
	movl	16(%esp), %ebx
	movl	20(%esp), %ecx
	int	$SYSC_SIGNAL
	popl	%ecx
	popl	%ebx
	ret

ENTRY(select)
	pushl	%ebx
	pushl	%ecx
	int     $SYSC_SELECT
	pushl   %ecx    
	pushl   %ebx    
	call    *%eax    
	addl    $8, %esp
	popl	%ecx
	popl	%ebx
	ret

ENTRY(timeout)
	pushl	%ebx
	pushl	%ecx
	movl	12(%esp), %eax
	movl	16(%esp), %ebx
	movl	20(%esp), %ecx
	int	$SYSC_TIMEOUT
	popl	%ecx
	popl	%ebx
	ret

ENTRY(quantum)
	pushl	%ebx
	pushl	%ecx
	movl	12(%esp), %eax
	movl	16(%esp), %ebx
	movl	20(%esp), %ecx
	int	$SYSC_QUANTUM
	popl	%ecx
	popl	%ebx
	ret

ENTRY(unmap)
	pushl	%ebx
	movl	8(%esp), %eax
	movl	12(%esp), %ebx
	int	$SYSC_UNMAP
	popl	%ebx
	ret

ENTRY(time)
	int	$SYSC_TIME
	ret

ENTRY(error)
	int	$SYSC_ERROR
	ret

ENTRY(putchar)
	pushl	%ebx
	movl	8(%esp), %eax
	movl	$0x0A, %ebx
	int	$SYSC_PUTCHAR
	popl	%ebx
	ret

ENTRY(getchar)
	int	$SYSC_GETCHAR
	ret

/* EOF */

