#include "kernel.h"

int stack_base=STACK_BASE;

void init_memory(void)
{
int i;
	for (i=0; i<MAX_PAGES;i++)
	  {
	    pages[i].base=UNDEF;
	    pages[i].size=UNDEF;
	  }

}

int kp3( sid_t s, int op )
{
  pager_message_t message;
  int i,j,err;
  i = socket2index( s, 3 );
	 
  switch( op ) {
  case IPC_SEND: {
    receive( s, (addr_t) &message, sizeof(message));
    //printf("KP3 for process: ",i);
    switch( message.event ) {
    case KP3_PAGE_FAULT: {
      all_p[i].mem_c++;
  
      //print_s("Akcia: "); print_i(all_p[i].mapping); print_s("Message arg1: "); print_i(message.arg1); print_s("\n");	  
      for (j=0;j<MAX_PAGES;j++)
	if (pages[j].base==UNDEF) { 
	  pages[j].owner=i;
	  pages[j].priority=0;
	  break;
	}
      if ( j == MAX_PAGES ) {
	print_s("PANIC:No free pages !\n");
	while(1);
      }
      
      if(message.arg1<CODE_SIZE) all_p[i].mapping=MAP_CODE;
     
      //zistujeme ci sa nezvacsuje stack (teda mapovana adresa je o 4 bajty dalej ako doposial namapovane stackove ramy 
      if (((all_p[i].stack_base & 0xfffff000) - message.arg1)<=64)
	{
	  //	  if (all_p[i].mapping == MAP_STACK) break;
	  //print_s("Mapujem stack");
	  mapto(init,stack_base,PAGE_SIZE,IPC_GRANT,IPC_MEMORY);
	  if (issue(s,stack_base,PAGE_SIZE,IPC_MAP,IPC_MEMORY, IPC_MAP_RW)==-1 && error()==5) break;
	  all_p[i].stack_base -= PAGE_SIZE;
	  stack_base+=PAGE_SIZE;
	  pages[j].base=stack_base & 0xfffff000;
	  pages[j].size=PAGE_SIZE;
	  pages[j].attrib=MAP_STACK;
	  //printf("   na adresu ", pages[j].base );putchar('\n');
	  return 0;
	}

      switch (all_p[i].mapping) {
      case MAP_NONE:
	printf("KP3: Segfault na adrese: ", message.arg1);
	return 0;
      case MAP_CODE:
	
	pages[j].size=CODE_SIZE;
	//kernelova adresa odkial mapujeme pre dany proces danu
	//stranku
	pages[j].base=message.arg1 & 0xfffff000;
	pages[j].attrib=MAP_CODE;
	err=issue(s,message.arg1 & 0xfffff000 , 4096, IPC_MAP, IPC_MEMORY, IPC_MAP_RO); 
	if(err==-1) 
	  {
	    if (error()==5) 
	      {
		//print_s("Mapovanie kodu nezbehlo, ponechavam MAP_CODE\n");
	      } else { print_s("PANIC!\n"); while (1) ; }
	  } else all_p[i].mapping=MAP_NONE;
	break;
      case MAP_DATA:
	if (message.arg1 >= (all_p[i].data_base-all_p[i].malloc_size) && message.arg1 < all_p[i].data_base)
	  {
	    print_s("Mapujem DATA .. "); 
	    pages[j].size=all_p[i].malloc_size;
	    print_s("  data_base = "); print_i( data_base_global );
	    err = mapto(init,data_base_global,all_p[i].malloc_size,IPC_GRANT,IPC_MEMORY);
	    print_s("Namapoval som od initu: "); print_i(err); print_s("\n");
	    if ( err == -1 ) { print_s("PANIC: init nedal pamat\n"); while(1); }
	    err = issue(s,data_base_global,4096/*all_p[i].malloc_size*/,IPC_MAP,IPC_MEMORY,IPC_MAP_RW);
	    print_s("Namapovanie cez issue: "); print_i(err); print_s("\nNastala chyba ");print_i(error());print_s("\n");
	    printf("malloc size = ", all_p[i].malloc_size );
	    if ( err == -1 ) { print_s("PANIC: nepodarilo sa namapovat\n"); while(1); }
	   
	    pages[j].base=data_base_global;
	    data_base_global+=all_p[i].malloc_size;
	    pages[j].attrib=MAP_DATA;
	    all_p[i].mapping=MAP_NONE;						
	    print_s("   O.K. ");
	  }
	break;
      case MAP_STACK: //len pri mapovani prvej stranky pre zasobnik forknuteho procesu
        mapto(init,stack_base,PAGE_SIZE,IPC_GRANT,IPC_MEMORY);
	issue(s,stack_base,PAGE_SIZE,IPC_MAP,IPC_MEMORY, IPC_MAP_RW);
	all_p[i].mapping=MAP_NONE;
	all_p[i].stack_base -= PAGE_SIZE;
	pages[j].base=stack_base & 0xfffff000;
	pages[j].size=PAGE_SIZE;
	pages[j].attrib=MAP_STACK;
	stack_base+=PAGE_SIZE;
	break;	
      }
      break;
    }
    default: {
      print_s("KP3: Unknown event !\n");
      break;
    }
    }
    break;
  }
  break; //symbolicky
  case IPC_RECEIVE: {
    printf("PANIC: KP3 request for SEND by process ",i);
    while(1);
  }
  case IPC_CONNECT: {
    print_s("KP3 request for CONNECT !\n");
    while(1);
  }
  }
  return 3;
}

int kp4( sid_t s, int op )
{
  pager_message_t message;

  switch( op ) {
  case IPC_SEND: {
    receive( s, (addr_t) &message, sizeof(message));
    switch( message.event ) {
    case KP4_PAGE_FAULT: {
      //print_s("KP4: Pagefault s argumentom: ");
      //print_i( message.arg1 );
      mapto( init, 1048576, 4096, IPC_GRANT, IPC_MEMORY );
      issue( s, 1048576, 4096, IPC_GRANT, IPC_MEMORY, 0 );
      break;
    }
    default: {
      print_s("KP4: Unknown event !\n");
      break;
    }
    }
    break;
  }
  case IPC_RECEIVE: {
    print_s("KP4: request for SEND !\n");
    break;
  }
  case IPC_CONNECT: {
    print_s("KP4: request for CONNECT !\n");
    break;
  }
  }
  return 4;
}

int mem_malloc( struct syscall *message, int index )
{
  int ret_val;


  all_p[index].malloc_size = ( message->arg1 & 0xfffff000 ) + PAGE_SIZE;
  
  all_p[index].mapping = MAP_DATA;

  ret_val = all_p[index].data_base;

  all_p[index].data_base += all_p[index].malloc_size;
  print_s("MEM_MALLOC: malloc size = "); print_i(all_p[index].malloc_size); print_s("\n");

  return ret_val;
}


int mem_free( struct syscall *message, int index )
{
  int i;

  message = 0;
  for( i=0; i<MAX_PAGES; i++ ) {
    if ( pages[i].owner == index ) {
      unmap( pages[i].base, pages[i].size );
      pages[i].base = UNDEF;
      pages[i].size = UNDEF;
    }
  }
  
  return 0;
}

int stack_transform( int p, int addr )  
{
  // transformuje adresu v stacku procesu p na adresu v priestore kernelu
                                     
  int i;
  int x;

  if ( addr < CODE_SIZE ) return addr;  // ak je to staticke adresy sa zhoduju

  for( i=0; i<MAX_PAGES; i++ ) {
    if ( pages[i].base == UNDEF ) continue;
    if ( pages[i].owner != p ) continue;
    if ( pages[i].attrib != MAP_STACK ) continue;
    x = STACK_BASE - addr;
    if ( x > 4096 ) {
      printf("PANIC: stack overflow for process ", p);
      // treba zaviest cislovanie stranok stacku pre kazdy proces
      while(1);
    }
    return (pages[i].base - x);
  }
  printf("PANIC: no stack for process ", p );
  while(1);
}



